config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
	resources :links, except:[:show,:edit,:update,:destroy] 
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/link.rb
class Link < ApplicationRecord
  validates_presence_of :url
  validates_uniqueness_of :slug
  validates_length_of :url, within: 3..6000, on: :create, message: "too long"
  validates_length_of :slug, within: 3..6000, on: :create, message: "too long"
	before_validation :generate_slug
  
	def generate_slug
		slug = SecureRandom.uuid[0..5] 
		slug_exist = Link.where(slug: slug).first
		if slug_exist.present?
			self.slug =	slug + SecureRandom.uuid[0..2]
		else
			self.slug = slug
		end
	end


end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/links_controller.rb
class LinksController < ApplicationController
  before_action :set_link, only: %i[ show edit update destroy ]

  # GET /links or /links.json
  def index
    @links = Link.all
  end

  # GET /links/1 or /links/1.json
  def show
  end

  # GET /links/new
  def new
    @link = Link.new
  end

  # POST /links or /links.json
  def create
    @link = Link.new(link_params)
   respond_to do |format|
     if @link.save
     format.html { redirect_to '/links', notice: "Link was successfully created." }
     format.json { render :show, status: :created, location: @link }
     else
     format.html { render :new, status: :unprocessable_entity }
     format.json { render json: @link.errors, status: :unprocessable_entity }
     end
   end
  end


  private
    # Use callbacks to share common setup or constraints between actions.
    def set_link
      @link = Link.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def link_params
        params.fetch(:link, {}).permit(:url, :slug)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/links_helper.rb
module LinksHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ShortUrl</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/links/_form.html.erb
<%= form_with(model: link, local: true) do |form| %>
  <% if link.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(link.errors.count, "error") %> prohibited this link from being saved:</h2>

      <ul>
        <% link.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="">
	 Url:     <%= form.text_field :url %>
</div>
  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/links/edit.html.erb
<h1>Editing Link</h1>

<%= render 'form', link: @link %>

<%= link_to 'Show', @link %> |
<%= link_to 'Back', links_path %>

app/views/links/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Links</h1>

<table>
  <thead>
    <tr>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @links.each do |lin| %>
      <tr>
        <td><%= link_to Rails.application.config.default_route + lin.slug,  lin.url  %></td>
      
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Link', new_link_path %>

app/views/links/new.html.erb
<h1>New Link</h1>

<%= render 'form', link: @link %>

<%= link_to 'Back', links_path %>

app/views/links/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_link_path(@link) %> |
<%= link_to 'Back', links_path %>